#!/usr/bin/env python
#/**
# *  Copyright (C) 2005 PGT-Linux.org http://www.pgt-linux.org
# *  Author: vandorpe Olivier <vandorpeo@pgt-linux.org>
# *
# *  This program is free software; you can redistribute it and/or modify
# *  it under the terms of the GNU General Public License as published by
# *  the Free Software Foundation; either version 2 of the License, or
# *  (at your option) any later version.
# *
# *  This program is distributed in the hope that it will be useful,
# *  but WITHOUT ANY WARRANTY; without even the implied warranty of
# *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# *  GNU General Public License for more details.
# *
# *  You should have received a copy of the GNU General Public License
# *  along with this program; if not, write to the Free Software
# *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# */

import gtk
import dbus, sys,socket


class GnomeMeetingUsbB2k:
  
  usbb2k_state="standby"
  s=None
  gnomemeeting_object=None

  def KeyTimeOut(self):
    print "KeyTimeOut"

  def PstnUsb(self,widget,event,data=None):
    if widget.get_active():
      self.s.send("SWITCH USB")
    else:
      self.s.send("SWITCH PSTN")
      
  def usbb2k_interrupt(self,sock,mode):
    data=sock.recv(100)
    if not data:
      sys.exit("Error usbb2k sock\n")
    print "data: ",data
    if data=='HANDSET ON':
      if self.usbb2k_state=="Ring":
	print "accept Call"
	self.gnomemeeting_object.Disconnect()
      else:
	print "wait number"
	self.usbb2k_state="WaitNum"
	  
    return True

  def destroy(self,widget,data=None):
    gtk.main_quit()
  
  def AddCall_signal_handler(self,interface, signal_name, service, path, message):
    data=message.get_args_list()
    msg=data[0]
    print ("AddCall: [%s] \n [%s]\n" %(msg,message))

  def DeleteCall_signal_handler(self,interface, signal_name, service, path, message):
    data=message.get_args_list()
    msg=data[0]
    print ("DeleteCall: [%s] \n [%s]\n" %( msg, message))

  def statechanged_signal_handler(self,interface, signal_name, service, path, message):
    data=message.get_args_list()
    msg=data[0]
    print ("DBUS [%s] \n %s" % (msg,message))
    if msg=='Called':
      print "Called mode"
      self.s.send("RING 1")
      self.usbb2k_state="Ring"

    if msg=='Standby':
      print "Standby mode"
      if self.usbb2k_state=="Ring":
        print "End Ring state"
        self.usbb2k_state="standby"
        self.s.send("RING 0")

  def __init__(self):
    bus = dbus.SessionBus()
    self.ring_state=False
    self.s = socket.socket(socket.AF_UNIX,socket.SOCK_STREAM)
    self.s.connect("/tmp/usbb2k.sock")
    if self.s:
      th_usbb2k_read=gtk.input_add(self.s,gtk.gdk.INPUT_READ,self.usbb2k_interrupt)
      remote_bus = dbus.SessionBus()
      session_service_list = bus.get_service("org.freedesktop.DBus").get_object("/org/freedesktop/DBus", "org.freedesktop.DBus").ListServices()
      gnomemeeting_dbus = 0
      for service in session_service_list:
	if service=="org.gnomemeeting.instance":
	  gnomemeeting_dbus = 1
      
      if not gnomemeeting_dbus:
	print "gnomemeeting not found\n"
	sys.exit()
      gnomemeeting_service = bus.get_service("org.gnomemeeting.instance")
      self.gnomemeeting_object = gnomemeeting_service.get_object("/org/gnomemeeting/instance","org.gnomemeeting.instance")
      self.gnomemeeting_object.connect_to_signal("StateChanged", self.statechanged_signal_handler)
      self.gnomemeeting_object.connect_to_signal("AddCall", self.AddCall_signal_handler)
      self.gnomemeeting_object.connect_to_signal("DeleteCall", self.DeleteCall_signal_handler)
      self.window=gtk.Window(gtk.WINDOW_TOPLEVEL)
      self.window.connect("destroy",self.destroy)
      self.window.set_border_width(10)
      self.b_PstnUsb=gtk.ToggleButton("USB")
      self.b_PstnUsb.connect("clicked",self.PstnUsb,None)
      self.window.add(self.b_PstnUsb)
      self.b_PstnUsb.show()
      self.window.show()
  def main(self):
      gtk.main()

if __name__=="__main__":
  gb2k=GnomeMeetingUsbB2k()
  gb2k.main()

