/**
 *  Copyright (C) 2005 PGT-Linux.org http://www.pgt-linux.org
 *  Author: vandorpe Olivier <vandorpeo@pgt-linux.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define PID_MAXL 1000
#define MSG_MAXL 1000
#define telbox_idVendor 0x6993
#define telbox_idProduct 0xb001

//Interface
#define AUDIO_IN        0x01
#define AUDIO_OUT       0x02
#define CONTROL         0x03

#define USB_MSG_IN      USB_TYPE_CLASS
#define USB_MSG_OUT     USB_TYPE_CLASS | 0x01
#define TIME_OUT        1600

#define URB_LENGTH	16

#define OFF	0
#define ON	1
#define ERR	-1

#define USB_MODE	1
#define PSTN_MODE	2

#define CMD_NA		0
#define CMD_SWITCH_USB 	1
#define CMD_SWITCH_PSTN	2
#define CMD_QUIT	3
#define CMD_RING	4
// --- added by ant@loadtrax.com 30/10/2005 ---
#define CMD_TONE	5
// ---


//Commande URB
//
#define URB_INIT		0
#define URB_USB_ON		1
#define URB_USB_OFF		2
#define URB_LED_USB_ON 		3
#define URB_LED_USB_OFF		4
#define URB_TONE_ON		5
#define URB_TONE_OFF		6
#define URB_RING_ON		7
#define URB_RING_OFF		8
#define URB_HANDSET		9
#define URB_KEYPRESS		10
#define URB_KEYCODE		11

unsigned char URB_CMD[][URB_LENGTH]={
// INIT REGISTER
{ 0x8e,0x0a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x68 },
// USB / PSTN SWITCH CMD
// USB_ON 	
{ 0x0E,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF1 },
// USB_OFF
{ 0x0E,0x01,0x00,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf0 },
// LED_USB_ON
{ 0x05,0x02,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFA },
// LED_USB_OFF
{ 0x05,0x02,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFA },

// TONE / RING CMD
// TONE_ON
{ 0x09,0x01,0x00,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF5 },
// TONE_OFF
{ 0x09,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF6 },
// RING ON
{ 0x01,0x01,0x00,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFd },
  // RING OFF
{ 0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFe },

// KEY/HANDSET DETECTION
// HANDSET QUERY 
{ 0x8d,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x72 },
// KEY QUERY
{ 0x80,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F },
// KEY CODE
{ 0x81,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7e },
};  
/*char T_DECROCHE2[16]={ 0x04,0x01,0x00,0x0b,0xa6,0x00,0x00,0x00,
                    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4a };
char T_DECROCHE3[16]={ 0x05,0x02,0x00,0x00,0xff,0x00,0x00,0x00,
                    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfa };
char T_DECROCHE4[16]={ 0x0e,0x01,0x00,0x00,0x00,0x00,0x00,0x00,
                    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf1 };
char T_TEST[16]={ 0x07,0x01,0x00,0x00,0x00,0x00,0x00,0x00,
                    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf7 };
*/

typedef struct {
  int sock;
  usb_dev_handle *dev_h;
}client_arg_t;

int ringing_state=OFF;	/* RING LOOP ON/OFF */
int ringing_mode=OFF;	/* RINGING MODE ON/OFF */
int handset_state=OFF;  /* HANDSET STATE ON/OFF */

int usb_loop=OFF;
int main_loop=OFF;

// --- added by ant@loadtrax.com 30.10.05 ---
char ringing_tone[MSG_MAXL];
// ---

