#!/usr/bin/env python
#/**
# *  Copyright (C) 2005 PGT-Linux.org http://www.pgt-linux.org
# *  Author: vandorpe Olivier <vandorpeo@pgt-linux.org>
# *
# *  This program is free software; you can redistribute it and/or modify
# *  it under the terms of the GNU General Public License as published by
# *  the Free Software Foundation; either version 2 of the License, or
# *  (at your option) any later version.
# *
# *  This program is distributed in the hope that it will be useful,
# *  but WITHOUT ANY WARRANTY; without even the implied warranty of
# *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# *  GNU General Public License for more details.
# *
# *  You should have received a copy of the GNU General Public License
# *  along with this program; if not, write to the Free Software
# *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# */

import gtk
import gobject
import sys,socket


class testUSBB2K:
  
  s=None

  def KeyTimeOut(self):
    print "KeyTimeOut"

  def PstnUsb(self,widget,data=None):
    if widget.get_active():
      if data=="USB":
        self.s.send("SWITCH USB")
      else:
        self.s.send("SWITCH PSTN")
  def Ring(self,widget,data=None):
    if widget.get_active():
      if data=="RING1":
      	self.s.send("RING 1 ");
      else:
        self.s.send("RING 0 ");	
  def usbb2k_interrupt(self,sock,mode):
    usbb2k_event=sock.recv(200)
    if not usbb2k_event:
      sys.exit("Error usbb2k sock\n")
    self.buffer.insert_at_cursor(usbb2k_event)
    return True

  def destroy(self,widget,data=None):
    gtk.main_quit()
  
  def __init__(self):
    self.ring_state=False
    self.s = socket.socket(socket.AF_UNIX,socket.SOCK_STREAM)
    self.s.connect("/tmp/usbb2k.sock")
    if self.s:
      th_usbb2k_read=gobject.io_add_watch(self.s,gobject.IO_IN,self.usbb2k_interrupt)
      self.window=gtk.Window(gtk.WINDOW_TOPLEVEL)
      self.window.set_title("USBB2K-API TEST")
      self.window.connect("destroy",self.destroy)
      self.window.set_border_width(0)
      self.box1=gtk.VBox(False,0)
      self.window.add(self.box1)
      
      sw=gtk.ScrolledWindow()
      sw.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
      textview=gtk.TextView(buffer=None)
      textview.set_editable(False)
      self.buffer=textview.get_buffer()
      sw.add(textview)
      sw.show() 
      textview.show()
      self.box1.pack_start(sw)
      
      button=gtk.RadioButton(None,"USB")
      button.connect("toggled",self.PstnUsb,"USB")
      self.box1.pack_start(button,True,True,0)
      button.show()

      button=gtk.RadioButton(button,"PSTN")
      button.connect("toggled",self.PstnUsb,"PSTN")
      self.box1.pack_start(button,True,True,0)
      button.show()
      
      button=gtk.RadioButton(None,"Ring tone1")
      button.connect("toggled",self.Ring,"RING1")
      self.box1.pack_start(button,True,True,0)
      button.show()

      button=gtk.RadioButton(button,"Ring off")
      button.connect("toggled",self.Ring,"RINGOFF")
      self.box1.pack_start(button,True,True,0)
      button.show()

      self.box1.show()
      self.window.show()
  def main(self):
      gtk.main()

if __name__=="__main__":
  usbb2k=testUSBB2K()
  usbb2k.main()

